// Package models provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen/v2 version v2.1.0 DO NOT EDIT.
package models

import (
	"encoding/json"
	"errors"
	"fmt"

	"github.com/oapi-codegen/runtime"
)

// Defines values for FSCCoreDelegationVersion.
const (
	FSCCoreDelegationVersionN100 FSCCoreDelegationVersion = "1.0.0"
)

// Defines values for FSCCoreErrorDomain.
const (
	ERRORDOMAININWAY   FSCCoreErrorDomain = "ERROR_DOMAIN_INWAY"
	ERRORDOMAINMANAGER FSCCoreErrorDomain = "ERROR_DOMAIN_MANAGER"
	ERRORDOMAINOUTWAY  FSCCoreErrorDomain = "ERROR_DOMAIN_OUTWAY"
)

// Defines values for FSCCoreFscVersion.
const (
	FSCCoreFscVersionN100 FSCCoreFscVersion = "1.0.0"
)

// Defines values for FSCCoreGrantType.
const (
	GRANTTYPEDELEGATEDSERVICECONNECTION  FSCCoreGrantType = "GRANT_TYPE_DELEGATED_SERVICE_CONNECTION"
	GRANTTYPEDELEGATEDSERVICEPUBLICATION FSCCoreGrantType = "GRANT_TYPE_DELEGATED_SERVICE_PUBLICATION"
	GRANTTYPESERVICECONNECTION           FSCCoreGrantType = "GRANT_TYPE_SERVICE_CONNECTION"
	GRANTTYPESERVICEPUBLICATION          FSCCoreGrantType = "GRANT_TYPE_SERVICE_PUBLICATION"
)

// Defines values for FSCCoreHashAlgorithm.
const (
	HASHALGORITHMSHA3512 FSCCoreHashAlgorithm = "HASH_ALGORITHM_SHA3_512"
)

// Defines values for FSCCoreInwayErrorsCode.
const (
	ERRORCODEACCESSTOKENEXPIRED  FSCCoreInwayErrorsCode = "ERROR_CODE_ACCESS_TOKEN_EXPIRED"
	ERRORCODEACCESSTOKENINVALID  FSCCoreInwayErrorsCode = "ERROR_CODE_ACCESS_TOKEN_INVALID"
	ERRORCODEACCESSTOKENMISSING  FSCCoreInwayErrorsCode = "ERROR_CODE_ACCESS_TOKEN_MISSING"
	ERRORCODESERVICENOTFOUND     FSCCoreInwayErrorsCode = "ERROR_CODE_SERVICE_NOT_FOUND"
	ERRORCODESERVICEUNREACHABLE  FSCCoreInwayErrorsCode = "ERROR_CODE_SERVICE_UNREACHABLE"
	ERRORCODEWRONGGROUPIDINTOKEN FSCCoreInwayErrorsCode = "ERROR_CODE_WRONG_GROUP_ID_IN_TOKEN"
)

// Defines values for FSCCoreJwkAlg.
const (
	ES256 FSCCoreJwkAlg = "ES256"
	ES384 FSCCoreJwkAlg = "ES384"
	ES512 FSCCoreJwkAlg = "ES512"
	PS256 FSCCoreJwkAlg = "PS256"
	PS384 FSCCoreJwkAlg = "PS384"
	PS512 FSCCoreJwkAlg = "PS512"
	RS256 FSCCoreJwkAlg = "RS256"
	RS384 FSCCoreJwkAlg = "RS384"
	RS512 FSCCoreJwkAlg = "RS512"
)

// Defines values for FSCCoreJwkKeyOps.
const (
	Decrypt    FSCCoreJwkKeyOps = "decrypt"
	DeriveBits FSCCoreJwkKeyOps = "deriveBits"
	DeriveKey  FSCCoreJwkKeyOps = "deriveKey"
	Encrypt    FSCCoreJwkKeyOps = "encrypt"
	Sign       FSCCoreJwkKeyOps = "sign"
	UnwrapKey  FSCCoreJwkKeyOps = "unwrapKey"
	Verify     FSCCoreJwkKeyOps = "verify"
	WrapKey    FSCCoreJwkKeyOps = "wrapKey"
)

// Defines values for FSCCoreJwkKty.
const (
	EC  FSCCoreJwkKty = "EC"
	RSA FSCCoreJwkKty = "RSA"
)

// Defines values for FSCCoreJwkUse.
const (
	Enc FSCCoreJwkUse = "enc"
	Sig FSCCoreJwkUse = "sig"
)

// Defines values for FSCCoreLoggingVersion.
const (
	N100 FSCCoreLoggingVersion = "1.0.0"
)

// Defines values for FSCCoreManagerErrorCode.
const (
	ERRORCODEGRANTCOMBINATIONNOTALLOWED           FSCCoreManagerErrorCode = "ERROR_CODE_GRANT_COMBINATION_NOT_ALLOWED"
	ERRORCODEINCORRECTGROUPID                     FSCCoreManagerErrorCode = "ERROR_CODE_INCORRECT_GROUP_ID"
	ERRORCODEINCORRECTPUBLICKEYTHUMBPRINT         FSCCoreManagerErrorCode = "ERROR_CODE_INCORRECT_PUBLIC_KEY_THUMBPRINT"
	ERRORCODEPEERCERTIFICATEVERIFICATIONFAILED    FSCCoreManagerErrorCode = "ERROR_CODE_PEER_CERTIFICATE_VERIFICATION_FAILED"
	ERRORCODEPEERIDSIGNATUREMISMATCH              FSCCoreManagerErrorCode = "ERROR_CODE_PEER_ID_SIGNATURE_MISMATCH"
	ERRORCODEPEERNOTPARTOFCONTRACT                FSCCoreManagerErrorCode = "ERROR_CODE_PEER_NOT_PART_OF_CONTRACT"
	ERRORCODESIGNATURECONTRACTCONTENTHASHMISMATCH FSCCoreManagerErrorCode = "ERROR_CODE_SIGNATURE_CONTRACT_CONTENT_HASH_MISMATCH"
	ERRORCODESIGNATUREVERIFICATIONFAILED          FSCCoreManagerErrorCode = "ERROR_CODE_SIGNATURE_VERIFICATION_FAILED"
	ERRORCODEUNKNOWNALGORITHMSIGNATURE            FSCCoreManagerErrorCode = "ERROR_CODE_UNKNOWN_ALGORITHM_SIGNATURE"
	ERRORCODEUNKNOWNHASHALGORITHMHASH             FSCCoreManagerErrorCode = "ERROR_CODE_UNKNOWN_HASH_ALGORITHM_HASH"
	ERRORCODEURLPATHCONTENTHASHMISMATCH           FSCCoreManagerErrorCode = "ERROR_CODE_URL_PATH_CONTENT_HASH_MISMATCH"
)

// Defines values for FSCCoreOAuthGrantType.
const (
	ClientCredentials FSCCoreOAuthGrantType = "client_credentials"
)

// Defines values for FSCCoreOAuthTokenType.
const (
	Bearer FSCCoreOAuthTokenType = "bearer"
)

// Defines values for FSCCoreOutwayErrorCode.
const (
	ERRORCODEMETHODUNSUPPORTED FSCCoreOutwayErrorCode = "ERROR_CODE_METHOD_UNSUPPORTED"
)

// Defines values for FSCCoreProtocol.
const (
	PROTOCOLTCPHTTP11 FSCCoreProtocol = "PROTOCOL_TCP_HTTP_1.1"
	PROTOCOLTCPHTTP2  FSCCoreProtocol = "PROTOCOL_TCP_HTTP_2"
)

// Defines values for FSCCoreServiceType.
const (
	SERVICETYPEDELEGATEDSERVICE FSCCoreServiceType = "SERVICE_TYPE_DELEGATED_SERVICE"
	SERVICETYPESERVICE          FSCCoreServiceType = "SERVICE_TYPE_SERVICE"
)

// Defines values for FSCCoreSortOrder.
const (
	FSCCoreSortOrderSORTORDERASCENDING  FSCCoreSortOrder = "SORT_ORDER_ASCENDING"
	FSCCoreSortOrderSORTORDERDESCENDING FSCCoreSortOrder = "SORT_ORDER_DESCENDING"
)

// Defines values for FSCCoreTokenErrorCode.
const (
	InvalidClient        FSCCoreTokenErrorCode = "invalid_client"
	InvalidGrant         FSCCoreTokenErrorCode = "invalid_grant"
	InvalidRequest       FSCCoreTokenErrorCode = "invalid_request"
	InvalidScope         FSCCoreTokenErrorCode = "invalid_scope"
	UnauthorizedClient   FSCCoreTokenErrorCode = "unauthorized_client"
	UnsupportedGrantType FSCCoreTokenErrorCode = "unsupported_grant_type"
)

// Defines values for FSCLoggingDestinationType.
const (
	DESTINATIONTYPEDELEGATEDDESTINATION FSCLoggingDestinationType = "DESTINATION_TYPE_DELEGATED_DESTINATION"
	DESTINATIONTYPEDESTINATION          FSCLoggingDestinationType = "DESTINATION_TYPE_DESTINATION"
)

// Defines values for FSCLoggingLogRecordDirection.
const (
	DIRECTIONINCOMING FSCLoggingLogRecordDirection = "DIRECTION_INCOMING"
	DIRECTIONOUTGOING FSCLoggingLogRecordDirection = "DIRECTION_OUTGOING"
)

// Defines values for FSCLoggingSortOrder.
const (
	FSCLoggingSortOrderSORTORDERASCENDING  FSCLoggingSortOrder = "SORT_ORDER_ASCENDING"
	FSCLoggingSortOrderSORTORDERDESCENDING FSCLoggingSortOrder = "SORT_ORDER_DESCENDING"
)

// Defines values for FSCLoggingSourceType.
const (
	SOURCETYPEDELEGATEDSOURCE FSCLoggingSourceType = "SOURCE_TYPE_DELEGATED_SOURCE"
	SOURCETYPESOURCE          FSCLoggingSourceType = "SOURCE_TYPE_SOURCE"
)

// FSCCoreContract A Contract
type FSCCoreContract struct {
	// Content The content of a Contract
	Content FSCCoreContractContent `json:"content"`

	// Signatures The accept, reject and revoke signatures
	Signatures FSCCoreSignatures `json:"signatures"`
}

// FSCCoreContractContent The content of a Contract
type FSCCoreContractContent struct {
	// CreatedAt A Unix timestamp of the creation date of the Contract
	CreatedAt int64 `json:"created_at"`

	// Grants The Grants of the Contract
	Grants []FSCCoreGrant `json:"grants"`

	// GroupId The FSC Group ID
	GroupId string `json:"group_id"`

	// HashAlgorithm The hashing algorithm
	HashAlgorithm FSCCoreHashAlgorithm `json:"hash_algorithm"`

	// Iv An Initialization vector for the Contract. Must be an UUID V7.
	Iv       string          `json:"iv"`
	Validity FSCCoreValidity `json:"validity"`
}

// FSCCoreDelegatedService The details of a Service that is offered on behalf of another Peer
type FSCCoreDelegatedService struct {
	// Delegator The details of a Delegator
	Delegator FSCCoreDelegator `json:"delegator"`

	// Name The name of a service
	Name FSCCoreServiceName `json:"name"`

	// PeerId The ID of a Peer
	PeerId FSCCorePeerID `json:"peer_id"`

	// Type The type of Service
	Type FSCCoreServiceType `json:"type"`
}

// FSCCoreDelegationVersion The version of the Delegation extension
type FSCCoreDelegationVersion string

// FSCCoreDelegator The details of a Delegator
type FSCCoreDelegator struct {
	// PeerId The ID of a Peer
	PeerId FSCCorePeerID `json:"peer_id"`
}

// FSCCoreDelegatorServiceListing The details of a Delegator
type FSCCoreDelegatorServiceListing struct {
	// PeerId The ID of a Peer
	PeerId FSCCorePeerID `json:"peer_id"`

	// PeerName The name of a Peer
	PeerName FSCCorePeerName `json:"peer_name"`
}

// FSCCoreDirectory The details of the Directory
type FSCCoreDirectory struct {
	// PeerId The ID of a Peer
	PeerId FSCCorePeerID `json:"peer_id"`
}

// FSCCoreEcPublicKey defines model for FSC_Core_ecPublicKey.
type FSCCoreEcPublicKey struct {
	Crv *string `json:"crv,omitempty"`

	// X Public Key x coordinate. This parameter contains the x coordinate for the
	// Elliptic Curve point. It is represented as the base64url encoding of
	// the octet string representation of the coordinate, as defined in
	// Section 2.3.5 of SEC1 [SEC1]. The length of this octet string MUST
	// be the full size of a coordinate for the curve specified in the "crv"
	// parameter. For example, if the value of "crv" is "P-521", the octet
	// string must be 66 octets long.
	X *[]byte `json:"x,omitempty"`

	// Y Public Key y coordinate. This parameter contains the y coordinate for the
	// Elliptic Curve point. It is represented as the base64url encoding of
	// the octet string representation of the coordinate, as defined in
	// Section 2.3.5 of SEC1 [SEC1]. The length of this octet string MUST
	// be the full size of a coordinate for the curve specified in the "crv"
	// parameter. For example, if the value of "crv" is "P-521", the octet
	// string must be 66 octets long.
	Y *[]byte `json:"y,omitempty"`
}

// FSCCoreEnabledExtensions A map of extensions and versions
type FSCCoreEnabledExtensions struct {
	// EXTENSIONDELEGATION The version of the Delegation extension
	EXTENSIONDELEGATION *FSCCoreDelegationVersion `json:"EXTENSION_DELEGATION,omitempty"`

	// EXTENSIONTRANSACTIONLOGGING The version of the Logging extension
	EXTENSIONTRANSACTIONLOGGING *FSCCoreLoggingVersion `json:"EXTENSION_TRANSACTION_LOGGING,omitempty"`
}

// FSCCoreError defines model for FSC_Core_error.
type FSCCoreError struct {
	// Code A unique code specifying the error
	Code FSCCoreErrorCode `json:"code"`

	// Domain The FSC component in which the error occurred
	Domain FSCCoreErrorDomain `json:"domain"`

	// Message A message describing the error
	Message string `json:"message"`
}

// FSCCoreErrorCode A unique code specifying the error
type FSCCoreErrorCode = string

// FSCCoreErrorDomain The FSC component in which the error occurred
type FSCCoreErrorDomain string

// FSCCoreFscVersion The version of the FSC specification
type FSCCoreFscVersion string

// FSCCoreGrant A Grant
type FSCCoreGrant struct {
	// Data The details of the Grant
	Data FSCCoreGrant_Data `json:"data"`
}

// FSCCoreGrant_Data The details of the Grant
type FSCCoreGrant_Data struct {
	union json.RawMessage
}

// FSCCoreGrantDelegatedServiceConnection A DelegatedServiceConnectionGrant
type FSCCoreGrantDelegatedServiceConnection struct {
	// Delegator The details of a Delegator
	Delegator FSCCoreDelegator `json:"delegator"`

	// Outway The details of the Outway for which a connection authorization was granted
	Outway  FSCCoreOutway                                  `json:"outway"`
	Service FSCCoreGrantDelegatedServiceConnection_Service `json:"service"`

	// Type The type of Grant
	Type FSCCoreGrantType `json:"type"`
}

// FSCCoreGrantDelegatedServiceConnection_Service defines model for FSCCoreGrantDelegatedServiceConnection.Service.
type FSCCoreGrantDelegatedServiceConnection_Service struct {
	union json.RawMessage
}

// FSCCoreGrantDelegatedServicePublication A DelegatedServicePublicationGrant
type FSCCoreGrantDelegatedServicePublication struct {
	// Delegator The details of a Delegator
	Delegator FSCCoreDelegator `json:"delegator"`

	// Directory The details of the Directory
	Directory FSCCoreDirectory `json:"directory"`

	// Service The details of a Service publication
	Service FSCCoreServicePublication `json:"service"`

	// Type The type of Grant
	Type FSCCoreGrantType `json:"type"`
}

// FSCCoreGrantServiceConnection A ServiceConnectionGrant
type FSCCoreGrantServiceConnection struct {
	// Outway The details of the Outway for which a connection authorization was granted
	Outway  FSCCoreOutway                         `json:"outway"`
	Service FSCCoreGrantServiceConnection_Service `json:"service"`

	// Type The type of Grant
	Type FSCCoreGrantType `json:"type"`
}

// FSCCoreGrantServiceConnection_Service defines model for FSCCoreGrantServiceConnection.Service.
type FSCCoreGrantServiceConnection_Service struct {
	union json.RawMessage
}

// FSCCoreGrantServicePublication A ServicePublicationGrant
type FSCCoreGrantServicePublication struct {
	// Directory The details of the Directory
	Directory FSCCoreDirectory `json:"directory"`

	// Service The details of a Service publication
	Service FSCCoreServicePublication `json:"service"`

	// Type The type of Grant
	Type FSCCoreGrantType `json:"type"`
}

// FSCCoreGrantType The type of Grant
type FSCCoreGrantType string

// FSCCoreHashAlgorithm The hashing algorithm
type FSCCoreHashAlgorithm string

// FSCCoreInwayErrorsCode Error reasons that can be produced by the Inway
type FSCCoreInwayErrorsCode string

// FSCCoreJwk The value of the "keys" parameter is an array of JWK values. By default, the order of the JWK values within the array does not imply an order of preference among them, although applications of JWK Sets can choose to assign a meaning to the order for their purposes, if desired.
type FSCCoreJwk struct {
	// Alg Public Key Algorithm. This parameter identifies the algorithm intended for
	// use with the key. The values used should either be registered in the
	// IANA "JSON Web Signature and Encryption Algorithms" registry
	// established by [JWA] or be a value that contains a Collision-
	// Resistant Name. The "alg" value is a case-sensitive ASCII string.
	// Use of this member is OPTIONAL.
	Alg *FSCCoreJwkAlg `json:"alg,omitempty"`

	// KeyOps Public Key Operations. This parameter identifies the operation(s)
	// for which the key is intended to be used. The "key_ops" parameter is
	// intended for use cases in which public, private, or symmetric keys
	// may be present.
	//
	// Its value is an array of key operation values.
	KeyOps *[]FSCCoreJwkKeyOps `json:"key_ops,omitempty"`

	// Kid Public Key ID. This parameter is used to match a specific key.  This
	// is used, for instance, to choose among a set of keys within a JWK Set
	// during key rollover.  The structure of the "kid" value is
	// unspecified.  When "kid" values are used within a JWK Set, different
	// keys within the JWK Set SHOULD use distinct "kid" values.  (One
	// example in which different keys might use the same "kid" value is if
	// they have different "kty" (key type) values but are considered to be
	// equivalent alternatives by the application using them.)  The "kid"
	// value is a case-sensitive string.  Use of this member is OPTIONAL.
	// When used with JWS or JWE, the "kid" value is used to match a JWS or
	// JWE "kid" Header Parameter value.
	Kid *string `json:"kid,omitempty"`

	// Kty Public Key Type. This parameter identifies the cryptographic algorithm
	// family used with the key, such as "RSA" or "EC".  "kty" values should
	// either be registered in the IANA "JSON Web Key Types" registry
	// established by [JWA] or be a value that contains a Collision-
	// Resistant Name. The "kty" value is a case-sensitive string.  This
	// member MUST be present in a JWK.
	Kty FSCCoreJwkKty `json:"kty"`

	// Use Public Key Use. This parameter identifies the intended use of
	// the public key. The "use" parameter is employed to indicate whether
	// a public key is used for encrypting data or verifying the signature
	// on data.
	Use *FSCCoreJwkUse `json:"use,omitempty"`

	// X5c Public Key X.509 certificate chain. This parameter contains a chain of one
	// or more PKIX certificates [RFC5280].  The certificate chain is
	// represented as a JSON array of certificate value strings.  Each
	// string in the array is a base64-encoded (Section 4 of [RFC4648] --
	// not base64url-encoded) DER [ITU.X690.1994] PKIX certificate value.
	// The PKIX certificate containing the key value MUST be the first
	// certificate.  This MAY be followed by additional certificates, with
	// each subsequent certificate being the one used to certify the
	// previous one.  The key in the first certificate MUST match the public
	// key represented by other members of the JWK.  Use of this member is
	// OPTIONAL.
	X5c *[]string `json:"x5c,omitempty"`

	// X5t Public Key X.509 certificate SHA-1 thumbprint. This parameter is a
	// base64url-encoded SHA-1 thumbprint (a.k.a. digest) of the DER
	// encoding of an X.509 certificate [RFC5280]. Note that certificate
	// thumbprints are also sometimes known as certificate fingerprints.
	// The key in the certificate MUST match the public key represented by
	// other members of the JWK. Use of this member is OPTIONAL.
	X5t *string `json:"x5t,omitempty"`

	// X5tS256 Public Key X.509 certificate SHA-256 thumbprint. This parameter is a base64url-encoded SHA-256 thumbprint (a.k.a. digest)
	// of the DER encoding of the X.509 certificate [RFC5280] corresponding
	// to the key used to digitally sign the JWS. Note that certificate
	// thumbprints are also sometimes known as certificate fingerprints.
	// Use of this Header Parameter is OPTIONAL.
	X5tS256 *string `json:"x5t#s256,omitempty"`

	// X5u Public Key X.509 URL. This parameter is a URI [RFC3986] that refers to a
	// resource for an X.509 public key certificate or certificate chain
	// [RFC5280].  The identified resource MUST provide a representation of
	// the certificate or certificate chain that conforms to RFC 5280
	// [RFC5280] in PEM-encoded form, with each certificate delimited as
	// specified in Section 6.1 of RFC 4945 [RFC4945].  The key in the first
	// certificate MUST match the public key represented by other members of
	// the JWK.  The protocol used to acquire the resource MUST provide
	// integrity protection; an HTTP GET request to retrieve the certificate
	// MUST use TLS [RFC2818] [RFC5246]; the identity of the server MUST be
	// validated, as per Section 6 of RFC 6125 [RFC6125].  Use of this
	// member is OPTIONAL.
	X5u   *string `json:"x5u,omitempty"`
	union json.RawMessage
}

// FSCCoreJwkAlg Public Key Algorithm. This parameter identifies the algorithm intended for
// use with the key. The values used should either be registered in the
// IANA "JSON Web Signature and Encryption Algorithms" registry
// established by [JWA] or be a value that contains a Collision-
// Resistant Name. The "alg" value is a case-sensitive ASCII string.
// Use of this member is OPTIONAL.
type FSCCoreJwkAlg string

// FSCCoreJwkKeyOps defines model for FSCCoreJwk.KeyOps.
type FSCCoreJwkKeyOps string

// FSCCoreJwkKty Public Key Type. This parameter identifies the cryptographic algorithm
// family used with the key, such as "RSA" or "EC".  "kty" values should
// either be registered in the IANA "JSON Web Key Types" registry
// established by [JWA] or be a value that contains a Collision-
// Resistant Name. The "kty" value is a case-sensitive string.  This
// member MUST be present in a JWK.
type FSCCoreJwkKty string

// FSCCoreJwkUse Public Key Use. This parameter identifies the intended use of
// the public key. The "use" parameter is employed to indicate whether
// a public key is used for encrypting data or verifying the signature
// on data.
type FSCCoreJwkUse string

// FSCCoreJwks JSON Web Key Set to validate JSON Web Signatures, according to [RFC 7517](https://www.ietf.org/rfc/rfc7517.txt), with the additional restrictions on algorithms listed in the [FSC](https://commonground.gitlab.io/standards/fsc/core/draft-fsc-core-00.html#name-access-token)
type FSCCoreJwks struct {
	Keys []FSCCoreJwk `json:"keys"`
}

// FSCCoreLoggingVersion The version of the Logging extension
type FSCCoreLoggingVersion string

// FSCCoreManagerErrorCode Error reasons that can be produced by the Manager
type FSCCoreManagerErrorCode string

// FSCCoreOAuthGrantType The grant_type of an access token request. FSC only uses client_credentials
type FSCCoreOAuthGrantType string

// FSCCoreOAuthTokenType The type of token. FSC only uses Bearer
type FSCCoreOAuthTokenType string

// FSCCoreOutway The details of the Outway for which a connection authorization was granted
type FSCCoreOutway struct {
	// PeerId The ID of a Peer
	PeerId FSCCorePeerID `json:"peer_id"`

	// PublicKeyThumbprint The SHA-256 thumbprint of the public key used in the certificate of the Outway in HEX-encoded format
	PublicKeyThumbprint FSCCorePublicKeyThumbprint `json:"public_key_thumbprint"`
}

// FSCCoreOutwayErrorCode Error reasons that can be produced by the Outway
type FSCCoreOutwayErrorCode string

// FSCCorePaginationResult defines model for FSC_Core_paginationResult.
type FSCCorePaginationResult struct {
	// NextCursor A cursor that can be used to retrieve the next page or an empty string if there are no more results
	NextCursor *string `json:"next_cursor,omitempty"`
}

// FSCCorePeer defines model for FSC_Core_peer.
type FSCCorePeer struct {
	// Id The ID of a Peer
	Id FSCCorePeerID `json:"id"`

	// ManagerAddress The address of the Manager
	ManagerAddress string `json:"manager_address"`

	// Name The name of a Peer
	Name FSCCorePeerName `json:"name"`
}

// FSCCorePeerID The ID of a Peer
type FSCCorePeerID = string

// FSCCorePeerName The name of a Peer
type FSCCorePeerName = string

// FSCCoreProtocol application layer protocol supported
type FSCCoreProtocol string

// FSCCorePublicKeyThumbprint The SHA-256 thumbprint of the public key used in the certificate of the Outway in HEX-encoded format
type FSCCorePublicKeyThumbprint = string

// FSCCoreRsaPublicKey defines model for FSC_Core_rsaPublicKey.
type FSCCoreRsaPublicKey struct {
	// E Public Key exponent. This parameter contains the exponent value for the RSA
	// public key. It is represented as a Base64urlUInt-encoded value.
	//
	// For instance, when representing the value 65537, the octet sequence
	// to be base64url-encoded MUST consist of the three octets [1, 0, 1];
	// the resulting representation for this value is "AQAB".
	E *[]byte `json:"e,omitempty"`

	// N Public Key modulus. This parameter contains the modulus value for the RSA
	// public key. It is represented as a Base64urlUInt-encoded value.
	//
	// Note that implementers have found that some cryptographic libraries
	// prefix an extra zero-valued octet to the modulus representations they
	// return, for instance, returning 257 octets for a 2048-bit key, rather
	// than 256. Implementations using such libraries will need to take
	// care to omit the extra octet from the base64url-encoded
	// representation.
	N *[]byte `json:"n,omitempty"`
}

// FSCCoreService The details of a Service
type FSCCoreService struct {
	// Name The name of a service
	Name FSCCoreServiceName `json:"name"`

	// PeerId The ID of a Peer
	PeerId FSCCorePeerID `json:"peer_id"`

	// Type The type of Service
	Type FSCCoreServiceType `json:"type"`
}

// FSCCoreServiceListing defines model for FSC_Core_serviceListing.
type FSCCoreServiceListing struct {
	Data FSCCoreServiceListing_Data `json:"data"`
}

// FSCCoreServiceListing_Data defines model for FSCCoreServiceListing.Data.
type FSCCoreServiceListing_Data struct {
	union json.RawMessage
}

// FSCCoreServiceListingDelegatedService defines model for FSC_Core_serviceListingDelegatedService.
type FSCCoreServiceListingDelegatedService struct {
	// Delegator The details of a Delegator
	Delegator FSCCoreDelegatorServiceListing `json:"delegator"`

	// Name The name of a service
	Name FSCCoreServiceName `json:"name"`
	Peer FSCCorePeer        `json:"peer"`

	// Protocol application layer protocol supported
	Protocol FSCCoreProtocol `json:"protocol"`

	// Type The type of Service
	Type FSCCoreServiceType `json:"type"`
}

// FSCCoreServiceListingService defines model for FSC_Core_serviceListingService.
type FSCCoreServiceListingService struct {
	// Name The name of a service
	Name FSCCoreServiceName `json:"name"`
	Peer FSCCorePeer        `json:"peer"`

	// Protocol application layer protocol supported
	Protocol FSCCoreProtocol `json:"protocol"`

	// Type The type of Service
	Type FSCCoreServiceType `json:"type"`
}

// FSCCoreServiceName The name of a service
type FSCCoreServiceName = string

// FSCCoreServicePublication The details of a Service publication
type FSCCoreServicePublication struct {
	// Name The name of a service
	Name FSCCoreServiceName `json:"name"`

	// PeerId The ID of a Peer
	PeerId FSCCorePeerID `json:"peer_id"`

	// Protocol application layer protocol supported
	Protocol FSCCoreProtocol `json:"protocol"`
}

// FSCCoreServiceType The type of Service
type FSCCoreServiceType string

// FSCCoreSignatureMap Map of PeerIDs and accept signatures
type FSCCoreSignatureMap map[string]string

// FSCCoreSignatures The accept, reject and revoke signatures
type FSCCoreSignatures struct {
	// Accept Map of PeerIDs and accept signatures
	Accept FSCCoreSignatureMap `json:"accept"`

	// Reject Map of PeerIDs and accept signatures
	Reject FSCCoreSignatureMap `json:"reject"`

	// Revoke Map of PeerIDs and accept signatures
	Revoke FSCCoreSignatureMap `json:"revoke"`
}

// FSCCoreSortOrder The order in which the results should be returned
type FSCCoreSortOrder string

// FSCCoreTokenErrorCode one of the error codes described in https://www.rfc-editor.org/rfc/rfc6749#section-5.2
type FSCCoreTokenErrorCode string

// FSCCoreValidity defines model for FSC_Core_validity.
type FSCCoreValidity struct {
	// NotAfter A Unix timestamp, the Contract is not valid after this date.
	NotAfter int64 `json:"not_after"`

	// NotBefore A Unix timestamp, the Contract is not valid before this date.
	NotBefore int64 `json:"not_before"`
}

// FSCLoggingDestination Details of the Peer offering the Service
type FSCLoggingDestination struct {
	// ServicePeerId The ID of a Peer
	ServicePeerId FSCLoggingPeerID          `json:"service_peer_id"`
	Type          FSCLoggingDestinationType `json:"type"`
}

// FSCLoggingDestinationDelegated Details of the Peer offering the Service and the Delegator
type FSCLoggingDestinationDelegated struct {
	// DelegatorPeerId The ID of a Peer
	DelegatorPeerId FSCLoggingPeerID `json:"delegator_peer_id"`

	// ServicePeerId The ID of a Peer
	ServicePeerId FSCLoggingPeerID          `json:"service_peer_id"`
	Type          FSCLoggingDestinationType `json:"type"`
}

// FSCLoggingDestinationType defines model for FSC_Logging_destinationType.
type FSCLoggingDestinationType string

// FSCLoggingGrantHash The hash of a Grant
type FSCLoggingGrantHash = string

// FSCLoggingLogRecord A log record
type FSCLoggingLogRecord struct {
	// CreatedAt A Unix timestamp
	CreatedAt   FSCLoggingTimestamp             `json:"created_at"`
	Destination FSCLoggingLogRecord_Destination `json:"destination"`

	// Direction The direction of a request. I.e. is the request being send or received
	Direction FSCLoggingLogRecordDirection `json:"direction"`

	// GrantHash The hash of a Grant
	GrantHash FSCLoggingGrantHash `json:"grant_hash"`

	// ServiceName The name of a service
	ServiceName FSCLoggingServiceName      `json:"service_name"`
	Source      FSCLoggingLogRecord_Source `json:"source"`

	// TransactionId UUID v7
	TransactionId FSCLoggingUuid `json:"transaction_id"`
}

// FSCLoggingLogRecord_Destination defines model for FSCLoggingLogRecord.Destination.
type FSCLoggingLogRecord_Destination struct {
	union json.RawMessage
}

// FSCLoggingLogRecordDirection The direction of a request. I.e. is the request being send or received
type FSCLoggingLogRecordDirection string

// FSCLoggingLogRecord_Source defines model for FSCLoggingLogRecord.Source.
type FSCLoggingLogRecord_Source struct {
	union json.RawMessage
}

// FSCLoggingPaginationResult defines model for FSC_Logging_paginationResult.
type FSCLoggingPaginationResult struct {
	// NextCursor A cursor that can be used to retrieve the next page or an empty string if there are no more results
	NextCursor string `json:"next_cursor"`
}

// FSCLoggingPeerID The ID of a Peer
type FSCLoggingPeerID = string

// FSCLoggingServiceName The name of a service
type FSCLoggingServiceName = string

// FSCLoggingSortOrder The order in which the results should be returned
type FSCLoggingSortOrder string

// FSCLoggingSource Details of the Peer initiating the request
type FSCLoggingSource struct {
	// OutwayPeerId The ID of a Peer
	OutwayPeerId FSCLoggingPeerID     `json:"outway_peer_id"`
	Type         FSCLoggingSourceType `json:"type"`
}

// FSCLoggingSourceDelegated Details of the Peer initiating the request and the Delegator
type FSCLoggingSourceDelegated struct {
	// DelegatorPeerId The ID of a Peer
	DelegatorPeerId FSCLoggingPeerID `json:"delegator_peer_id"`

	// OutwayPeerId The ID of a Peer
	OutwayPeerId FSCLoggingPeerID     `json:"outway_peer_id"`
	Type         FSCLoggingSourceType `json:"type"`
}

// FSCLoggingSourceType defines model for FSC_Logging_sourceType.
type FSCLoggingSourceType string

// FSCLoggingTimestamp A Unix timestamp
type FSCLoggingTimestamp = int64

// FSCLoggingUuid UUID v7
type FSCLoggingUuid = string

// FSCCoreHeaderFscManagerAddress defines model for FSC_Core_headerFscManagerAddress.
type FSCCoreHeaderFscManagerAddress = string

// FSCCorePathContractContentHash defines model for FSC_Core_pathContractContentHash.
type FSCCorePathContractContentHash = string

// FSCCoreQueryPaginationCursor defines model for FSC_Core_queryPaginationCursor.
type FSCCoreQueryPaginationCursor = string

// FSCCoreQueryPaginationLimit defines model for FSC_Core_queryPaginationLimit.
type FSCCoreQueryPaginationLimit = uint32

// FSCCoreQueryPaginationOrder The order in which the results should be returned
type FSCCoreQueryPaginationOrder = FSCCoreSortOrder

// FSCLoggingQueryPaginationCursor defines model for FSC_Logging_queryPaginationCursor.
type FSCLoggingQueryPaginationCursor = string

// FSCLoggingQueryPaginationLimit defines model for FSC_Logging_queryPaginationLimit.
type FSCLoggingQueryPaginationLimit = uint32

// FSCLoggingQueryPaginationOrder The order in which the results should be returned
type FSCLoggingQueryPaginationOrder = FSCLoggingSortOrder

// FSCCoreSignatureRequest defines model for FSC_Core_signatureRequest.
type FSCCoreSignatureRequest struct {
	// ContractContent The content of a Contract
	ContractContent FSCCoreContractContent `json:"contract_content"`

	// Signature The signature
	Signature string `json:"signature"`
}

// AnnounceParams defines parameters for Announce.
type AnnounceParams struct {
	// FscManagerAddress The URL of the Manager. The scheme must be https and the URL must contain the port.
	FscManagerAddress FSCCoreHeaderFscManagerAddress `json:"fsc-manager-address"`
}

// GetContractsParams defines parameters for GetContracts.
type GetContractsParams struct {
	// Cursor A cursor from which paginated results should be returned. Leave empty for the first page
	Cursor *FSCCoreQueryPaginationCursor `form:"cursor,omitempty" json:"cursor,omitempty"`

	// Limit The maximum number of results
	Limit *FSCCoreQueryPaginationLimit `form:"limit,omitempty" json:"limit,omitempty"`

	// SortOrder The sorting order of the results
	SortOrder *FSCCoreQueryPaginationOrder `form:"sort_order,omitempty" json:"sort_order,omitempty"`

	// GrantType A Grant type on which to filter. Returns Contracts which contain a Grant of the Grant Type specified in the grant_type filter
	GrantType *FSCCoreGrantType `form:"grant_type,omitempty" json:"grant_type,omitempty"`

	// GrantHash A list of Grant hashes on which to filter. Returns Contracts that contain a Grant with the same Grant hash as specified in the grant_hash filter.  When this query parameter is set the pagination parameters and the GrantType filter should be ignored
	GrantHash *[]string `form:"grant_hash,omitempty" json:"grant_hash,omitempty"`
}

// SubmitContractJSONBody defines parameters for SubmitContract.
type SubmitContractJSONBody struct {
	// ContractContent The content of a Contract
	ContractContent FSCCoreContractContent `json:"contract_content"`

	// Signature An accept signature of the Peer submitting the contract
	Signature string `json:"signature"`
}

// SubmitContractParams defines parameters for SubmitContract.
type SubmitContractParams struct {
	// FscManagerAddress The URL of the Manager. The scheme must be https and the URL must contain the port.
	FscManagerAddress FSCCoreHeaderFscManagerAddress `json:"fsc-manager-address"`
}

// AcceptContractJSONBody defines parameters for AcceptContract.
type AcceptContractJSONBody struct {
	// ContractContent The content of a Contract
	ContractContent FSCCoreContractContent `json:"contract_content"`

	// Signature The signature
	Signature string `json:"signature"`
}

// AcceptContractParams defines parameters for AcceptContract.
type AcceptContractParams struct {
	// FscManagerAddress The URL of the Manager. The scheme must be https and the URL must contain the port.
	FscManagerAddress FSCCoreHeaderFscManagerAddress `json:"fsc-manager-address"`
}

// RejectContractJSONBody defines parameters for RejectContract.
type RejectContractJSONBody struct {
	// ContractContent The content of a Contract
	ContractContent FSCCoreContractContent `json:"contract_content"`

	// Signature The signature
	Signature string `json:"signature"`
}

// RejectContractParams defines parameters for RejectContract.
type RejectContractParams struct {
	// FscManagerAddress The URL of the Manager. The scheme must be https and the URL must contain the port.
	FscManagerAddress FSCCoreHeaderFscManagerAddress `json:"fsc-manager-address"`
}

// RevokeContractJSONBody defines parameters for RevokeContract.
type RevokeContractJSONBody struct {
	// ContractContent The content of a Contract
	ContractContent FSCCoreContractContent `json:"contract_content"`

	// Signature The signature
	Signature string `json:"signature"`
}

// RevokeContractParams defines parameters for RevokeContract.
type RevokeContractParams struct {
	// FscManagerAddress The URL of the Manager. The scheme must be https and the URL must contain the port.
	FscManagerAddress FSCCoreHeaderFscManagerAddress `json:"fsc-manager-address"`
}

// GetLogsParams defines parameters for GetLogs.
type GetLogsParams struct {
	// Cursor A cursor from which paginated results should be returned. Leave empty for the first page
	Cursor *FSCLoggingQueryPaginationCursor `form:"cursor,omitempty" json:"cursor,omitempty"`

	// Limit The maximum number of results
	Limit *FSCLoggingQueryPaginationLimit `form:"limit,omitempty" json:"limit,omitempty"`

	// SortOrder The sorting order of the results
	SortOrder *FSCLoggingQueryPaginationOrder `form:"sort_order,omitempty" json:"sort_order,omitempty"`

	// After Log records with a creation date after this value will be returned
	After *FSCLoggingTimestamp `form:"after,omitempty" json:"after,omitempty"`

	// Before Log records with a creation date before this value will be returned
	Before *FSCLoggingTimestamp `form:"before,omitempty" json:"before,omitempty"`

	// GrantHash A list of Grant hashes on which to filter. When multiple filters are used the records where either condition is true should be returned
	GrantHash *[]FSCLoggingGrantHash `form:"grant_hash,omitempty" json:"grant_hash,omitempty"`

	// ServiceName A list of service names on which to filter. When multiple filters are used the records where either condition is true should be returned
	ServiceName *[]FSCLoggingServiceName `form:"service_name,omitempty" json:"service_name,omitempty"`

	// TransactionIds A list of transaction IDs on which to filter. When this query parameter is set the pagination parameters and other filters should be ignored
	TransactionIds *[]FSCLoggingUuid `form:"transaction_ids,omitempty" json:"transaction_ids,omitempty"`
}

// GetPeersParams defines parameters for GetPeers.
type GetPeersParams struct {
	// Cursor A cursor from which paginated results should be returned. Leave empty for the first page
	Cursor *FSCCoreQueryPaginationCursor `form:"cursor,omitempty" json:"cursor,omitempty"`

	// Limit The maximum number of results
	Limit *FSCCoreQueryPaginationLimit `form:"limit,omitempty" json:"limit,omitempty"`

	// SortOrder The sorting order of the results
	SortOrder *FSCCoreQueryPaginationOrder `form:"sort_order,omitempty" json:"sort_order,omitempty"`

	// PeerName A Peer name on which to filter. The search is case insensitive. Return all Peers with a name that contains the peer_name filter
	PeerName *FSCCorePeerName `form:"peer_name,omitempty" json:"peer_name,omitempty"`

	// PeerId A list of Peer IDs on which to filter. When this query parameter is set the pagination parameters and other filters should be ignored
	PeerId *[]FSCCorePeerID `form:"peer_id,omitempty" json:"peer_id,omitempty"`
}

// GetServicesParams defines parameters for GetServices.
type GetServicesParams struct {
	// Cursor A cursor from which paginated results should be returned. Leave empty for the first page
	Cursor *FSCCoreQueryPaginationCursor `form:"cursor,omitempty" json:"cursor,omitempty"`

	// Limit The maximum number of results
	Limit *FSCCoreQueryPaginationLimit `form:"limit,omitempty" json:"limit,omitempty"`

	// SortOrder The sorting order of the results
	SortOrder *FSCCoreQueryPaginationOrder `form:"sort_order,omitempty" json:"sort_order,omitempty"`

	// PeerId A Peer ID on which to filter. Returns Services offered by the Peer defined in the PeerID filter. When multiple filters are used the Services where either condition is true should be returned
	PeerId *FSCCorePeerID `form:"peer_id,omitempty" json:"peer_id,omitempty"`

	// ServiceName A Service name on which to filter. The search is case insensitive. Returns Services with a name that contains the Service name filter. When multiple filters are used the Services where either condition is true should be returned
	ServiceName *FSCCoreServiceName `form:"service_name,omitempty" json:"service_name,omitempty"`
}

// GetTokenFormdataBody defines parameters for GetToken.
type GetTokenFormdataBody struct {
	// ClientId The ID of a Peer
	ClientId FSCCorePeerID `form:"client_id" json:"client_id"`

	// GrantType The grant_type of an access token request. FSC only uses client_credentials
	GrantType FSCCoreOAuthGrantType `form:"grant_type" json:"grant_type"`

	// Scope The scope should contain the hash of the Grant that contains the authorization for a connection to a Service
	Scope string `form:"scope" json:"scope"`
}

// SubmitContractJSONRequestBody defines body for SubmitContract for application/json ContentType.
type SubmitContractJSONRequestBody SubmitContractJSONBody

// AcceptContractJSONRequestBody defines body for AcceptContract for application/json ContentType.
type AcceptContractJSONRequestBody AcceptContractJSONBody

// RejectContractJSONRequestBody defines body for RejectContract for application/json ContentType.
type RejectContractJSONRequestBody RejectContractJSONBody

// RevokeContractJSONRequestBody defines body for RevokeContract for application/json ContentType.
type RevokeContractJSONRequestBody RevokeContractJSONBody

// GetTokenFormdataRequestBody defines body for GetToken for application/x-www-form-urlencoded ContentType.
type GetTokenFormdataRequestBody GetTokenFormdataBody

// AsFSCCoreGrantServicePublication returns the union data inside the FSCCoreGrant_Data as a FSCCoreGrantServicePublication
func (t FSCCoreGrant_Data) AsFSCCoreGrantServicePublication() (FSCCoreGrantServicePublication, error) {
	var body FSCCoreGrantServicePublication
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromFSCCoreGrantServicePublication overwrites any union data inside the FSCCoreGrant_Data as the provided FSCCoreGrantServicePublication
func (t *FSCCoreGrant_Data) FromFSCCoreGrantServicePublication(v FSCCoreGrantServicePublication) error {
	v.Type = "GRANT_TYPE_SERVICE_PUBLICATION"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeFSCCoreGrantServicePublication performs a merge with any union data inside the FSCCoreGrant_Data, using the provided FSCCoreGrantServicePublication
func (t *FSCCoreGrant_Data) MergeFSCCoreGrantServicePublication(v FSCCoreGrantServicePublication) error {
	v.Type = "GRANT_TYPE_SERVICE_PUBLICATION"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsFSCCoreGrantServiceConnection returns the union data inside the FSCCoreGrant_Data as a FSCCoreGrantServiceConnection
func (t FSCCoreGrant_Data) AsFSCCoreGrantServiceConnection() (FSCCoreGrantServiceConnection, error) {
	var body FSCCoreGrantServiceConnection
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromFSCCoreGrantServiceConnection overwrites any union data inside the FSCCoreGrant_Data as the provided FSCCoreGrantServiceConnection
func (t *FSCCoreGrant_Data) FromFSCCoreGrantServiceConnection(v FSCCoreGrantServiceConnection) error {
	v.Type = "GRANT_TYPE_SERVICE_CONNECTION"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeFSCCoreGrantServiceConnection performs a merge with any union data inside the FSCCoreGrant_Data, using the provided FSCCoreGrantServiceConnection
func (t *FSCCoreGrant_Data) MergeFSCCoreGrantServiceConnection(v FSCCoreGrantServiceConnection) error {
	v.Type = "GRANT_TYPE_SERVICE_CONNECTION"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsFSCCoreGrantDelegatedServiceConnection returns the union data inside the FSCCoreGrant_Data as a FSCCoreGrantDelegatedServiceConnection
func (t FSCCoreGrant_Data) AsFSCCoreGrantDelegatedServiceConnection() (FSCCoreGrantDelegatedServiceConnection, error) {
	var body FSCCoreGrantDelegatedServiceConnection
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromFSCCoreGrantDelegatedServiceConnection overwrites any union data inside the FSCCoreGrant_Data as the provided FSCCoreGrantDelegatedServiceConnection
func (t *FSCCoreGrant_Data) FromFSCCoreGrantDelegatedServiceConnection(v FSCCoreGrantDelegatedServiceConnection) error {
	v.Type = "GRANT_TYPE_DELEGATED_SERVICE_CONNECTION"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeFSCCoreGrantDelegatedServiceConnection performs a merge with any union data inside the FSCCoreGrant_Data, using the provided FSCCoreGrantDelegatedServiceConnection
func (t *FSCCoreGrant_Data) MergeFSCCoreGrantDelegatedServiceConnection(v FSCCoreGrantDelegatedServiceConnection) error {
	v.Type = "GRANT_TYPE_DELEGATED_SERVICE_CONNECTION"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsFSCCoreGrantDelegatedServicePublication returns the union data inside the FSCCoreGrant_Data as a FSCCoreGrantDelegatedServicePublication
func (t FSCCoreGrant_Data) AsFSCCoreGrantDelegatedServicePublication() (FSCCoreGrantDelegatedServicePublication, error) {
	var body FSCCoreGrantDelegatedServicePublication
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromFSCCoreGrantDelegatedServicePublication overwrites any union data inside the FSCCoreGrant_Data as the provided FSCCoreGrantDelegatedServicePublication
func (t *FSCCoreGrant_Data) FromFSCCoreGrantDelegatedServicePublication(v FSCCoreGrantDelegatedServicePublication) error {
	v.Type = "GRANT_TYPE_DELEGATED_SERVICE_PUBLICATION"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeFSCCoreGrantDelegatedServicePublication performs a merge with any union data inside the FSCCoreGrant_Data, using the provided FSCCoreGrantDelegatedServicePublication
func (t *FSCCoreGrant_Data) MergeFSCCoreGrantDelegatedServicePublication(v FSCCoreGrantDelegatedServicePublication) error {
	v.Type = "GRANT_TYPE_DELEGATED_SERVICE_PUBLICATION"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t FSCCoreGrant_Data) Discriminator() (string, error) {
	var discriminator struct {
		Discriminator string `json:"type"`
	}
	err := json.Unmarshal(t.union, &discriminator)
	return discriminator.Discriminator, err
}

func (t FSCCoreGrant_Data) ValueByDiscriminator() (interface{}, error) {
	discriminator, err := t.Discriminator()
	if err != nil {
		return nil, err
	}
	switch discriminator {
	case "GRANT_TYPE_DELEGATED_SERVICE_CONNECTION":
		return t.AsFSCCoreGrantDelegatedServiceConnection()
	case "GRANT_TYPE_DELEGATED_SERVICE_PUBLICATION":
		return t.AsFSCCoreGrantDelegatedServicePublication()
	case "GRANT_TYPE_SERVICE_CONNECTION":
		return t.AsFSCCoreGrantServiceConnection()
	case "GRANT_TYPE_SERVICE_PUBLICATION":
		return t.AsFSCCoreGrantServicePublication()
	default:
		return nil, errors.New("unknown discriminator value: " + discriminator)
	}
}

func (t FSCCoreGrant_Data) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *FSCCoreGrant_Data) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsFSCCoreService returns the union data inside the FSCCoreGrantDelegatedServiceConnection_Service as a FSCCoreService
func (t FSCCoreGrantDelegatedServiceConnection_Service) AsFSCCoreService() (FSCCoreService, error) {
	var body FSCCoreService
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromFSCCoreService overwrites any union data inside the FSCCoreGrantDelegatedServiceConnection_Service as the provided FSCCoreService
func (t *FSCCoreGrantDelegatedServiceConnection_Service) FromFSCCoreService(v FSCCoreService) error {
	v.Type = "SERVICE_TYPE_SERVICE"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeFSCCoreService performs a merge with any union data inside the FSCCoreGrantDelegatedServiceConnection_Service, using the provided FSCCoreService
func (t *FSCCoreGrantDelegatedServiceConnection_Service) MergeFSCCoreService(v FSCCoreService) error {
	v.Type = "SERVICE_TYPE_SERVICE"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsFSCCoreDelegatedService returns the union data inside the FSCCoreGrantDelegatedServiceConnection_Service as a FSCCoreDelegatedService
func (t FSCCoreGrantDelegatedServiceConnection_Service) AsFSCCoreDelegatedService() (FSCCoreDelegatedService, error) {
	var body FSCCoreDelegatedService
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromFSCCoreDelegatedService overwrites any union data inside the FSCCoreGrantDelegatedServiceConnection_Service as the provided FSCCoreDelegatedService
func (t *FSCCoreGrantDelegatedServiceConnection_Service) FromFSCCoreDelegatedService(v FSCCoreDelegatedService) error {
	v.Type = "SERVICE_TYPE_DELEGATED_SERVICE"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeFSCCoreDelegatedService performs a merge with any union data inside the FSCCoreGrantDelegatedServiceConnection_Service, using the provided FSCCoreDelegatedService
func (t *FSCCoreGrantDelegatedServiceConnection_Service) MergeFSCCoreDelegatedService(v FSCCoreDelegatedService) error {
	v.Type = "SERVICE_TYPE_DELEGATED_SERVICE"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t FSCCoreGrantDelegatedServiceConnection_Service) Discriminator() (string, error) {
	var discriminator struct {
		Discriminator string `json:"type"`
	}
	err := json.Unmarshal(t.union, &discriminator)
	return discriminator.Discriminator, err
}

func (t FSCCoreGrantDelegatedServiceConnection_Service) ValueByDiscriminator() (interface{}, error) {
	discriminator, err := t.Discriminator()
	if err != nil {
		return nil, err
	}
	switch discriminator {
	case "SERVICE_TYPE_DELEGATED_SERVICE":
		return t.AsFSCCoreDelegatedService()
	case "SERVICE_TYPE_SERVICE":
		return t.AsFSCCoreService()
	default:
		return nil, errors.New("unknown discriminator value: " + discriminator)
	}
}

func (t FSCCoreGrantDelegatedServiceConnection_Service) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *FSCCoreGrantDelegatedServiceConnection_Service) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsFSCCoreService returns the union data inside the FSCCoreGrantServiceConnection_Service as a FSCCoreService
func (t FSCCoreGrantServiceConnection_Service) AsFSCCoreService() (FSCCoreService, error) {
	var body FSCCoreService
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromFSCCoreService overwrites any union data inside the FSCCoreGrantServiceConnection_Service as the provided FSCCoreService
func (t *FSCCoreGrantServiceConnection_Service) FromFSCCoreService(v FSCCoreService) error {
	v.Type = "SERVICE_TYPE_SERVICE"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeFSCCoreService performs a merge with any union data inside the FSCCoreGrantServiceConnection_Service, using the provided FSCCoreService
func (t *FSCCoreGrantServiceConnection_Service) MergeFSCCoreService(v FSCCoreService) error {
	v.Type = "SERVICE_TYPE_SERVICE"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsFSCCoreDelegatedService returns the union data inside the FSCCoreGrantServiceConnection_Service as a FSCCoreDelegatedService
func (t FSCCoreGrantServiceConnection_Service) AsFSCCoreDelegatedService() (FSCCoreDelegatedService, error) {
	var body FSCCoreDelegatedService
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromFSCCoreDelegatedService overwrites any union data inside the FSCCoreGrantServiceConnection_Service as the provided FSCCoreDelegatedService
func (t *FSCCoreGrantServiceConnection_Service) FromFSCCoreDelegatedService(v FSCCoreDelegatedService) error {
	v.Type = "SERVICE_TYPE_DELEGATED_SERVICE"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeFSCCoreDelegatedService performs a merge with any union data inside the FSCCoreGrantServiceConnection_Service, using the provided FSCCoreDelegatedService
func (t *FSCCoreGrantServiceConnection_Service) MergeFSCCoreDelegatedService(v FSCCoreDelegatedService) error {
	v.Type = "SERVICE_TYPE_DELEGATED_SERVICE"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t FSCCoreGrantServiceConnection_Service) Discriminator() (string, error) {
	var discriminator struct {
		Discriminator string `json:"type"`
	}
	err := json.Unmarshal(t.union, &discriminator)
	return discriminator.Discriminator, err
}

func (t FSCCoreGrantServiceConnection_Service) ValueByDiscriminator() (interface{}, error) {
	discriminator, err := t.Discriminator()
	if err != nil {
		return nil, err
	}
	switch discriminator {
	case "SERVICE_TYPE_DELEGATED_SERVICE":
		return t.AsFSCCoreDelegatedService()
	case "SERVICE_TYPE_SERVICE":
		return t.AsFSCCoreService()
	default:
		return nil, errors.New("unknown discriminator value: " + discriminator)
	}
}

func (t FSCCoreGrantServiceConnection_Service) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *FSCCoreGrantServiceConnection_Service) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsFSCCoreEcPublicKey returns the union data inside the FSCCoreJwk as a FSCCoreEcPublicKey
func (t FSCCoreJwk) AsFSCCoreEcPublicKey() (FSCCoreEcPublicKey, error) {
	var body FSCCoreEcPublicKey
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromFSCCoreEcPublicKey overwrites any union data inside the FSCCoreJwk as the provided FSCCoreEcPublicKey
func (t *FSCCoreJwk) FromFSCCoreEcPublicKey(v FSCCoreEcPublicKey) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeFSCCoreEcPublicKey performs a merge with any union data inside the FSCCoreJwk, using the provided FSCCoreEcPublicKey
func (t *FSCCoreJwk) MergeFSCCoreEcPublicKey(v FSCCoreEcPublicKey) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsFSCCoreRsaPublicKey returns the union data inside the FSCCoreJwk as a FSCCoreRsaPublicKey
func (t FSCCoreJwk) AsFSCCoreRsaPublicKey() (FSCCoreRsaPublicKey, error) {
	var body FSCCoreRsaPublicKey
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromFSCCoreRsaPublicKey overwrites any union data inside the FSCCoreJwk as the provided FSCCoreRsaPublicKey
func (t *FSCCoreJwk) FromFSCCoreRsaPublicKey(v FSCCoreRsaPublicKey) error {
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeFSCCoreRsaPublicKey performs a merge with any union data inside the FSCCoreJwk, using the provided FSCCoreRsaPublicKey
func (t *FSCCoreJwk) MergeFSCCoreRsaPublicKey(v FSCCoreRsaPublicKey) error {
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t FSCCoreJwk) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	if err != nil {
		return nil, err
	}
	object := make(map[string]json.RawMessage)
	if t.union != nil {
		err = json.Unmarshal(b, &object)
		if err != nil {
			return nil, err
		}
	}

	if t.Alg != nil {
		object["alg"], err = json.Marshal(t.Alg)
		if err != nil {
			return nil, fmt.Errorf("error marshaling 'alg': %w", err)
		}
	}

	if t.KeyOps != nil {
		object["key_ops"], err = json.Marshal(t.KeyOps)
		if err != nil {
			return nil, fmt.Errorf("error marshaling 'key_ops': %w", err)
		}
	}

	if t.Kid != nil {
		object["kid"], err = json.Marshal(t.Kid)
		if err != nil {
			return nil, fmt.Errorf("error marshaling 'kid': %w", err)
		}
	}

	object["kty"], err = json.Marshal(t.Kty)
	if err != nil {
		return nil, fmt.Errorf("error marshaling 'kty': %w", err)
	}

	if t.Use != nil {
		object["use"], err = json.Marshal(t.Use)
		if err != nil {
			return nil, fmt.Errorf("error marshaling 'use': %w", err)
		}
	}

	if t.X5c != nil {
		object["x5c"], err = json.Marshal(t.X5c)
		if err != nil {
			return nil, fmt.Errorf("error marshaling 'x5c': %w", err)
		}
	}

	if t.X5t != nil {
		object["x5t"], err = json.Marshal(t.X5t)
		if err != nil {
			return nil, fmt.Errorf("error marshaling 'x5t': %w", err)
		}
	}

	if t.X5tS256 != nil {
		object["x5t#s256"], err = json.Marshal(t.X5tS256)
		if err != nil {
			return nil, fmt.Errorf("error marshaling 'x5t#s256': %w", err)
		}
	}

	if t.X5u != nil {
		object["x5u"], err = json.Marshal(t.X5u)
		if err != nil {
			return nil, fmt.Errorf("error marshaling 'x5u': %w", err)
		}
	}
	b, err = json.Marshal(object)
	return b, err
}

func (t *FSCCoreJwk) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	if err != nil {
		return err
	}
	object := make(map[string]json.RawMessage)
	err = json.Unmarshal(b, &object)
	if err != nil {
		return err
	}

	if raw, found := object["alg"]; found {
		err = json.Unmarshal(raw, &t.Alg)
		if err != nil {
			return fmt.Errorf("error reading 'alg': %w", err)
		}
	}

	if raw, found := object["key_ops"]; found {
		err = json.Unmarshal(raw, &t.KeyOps)
		if err != nil {
			return fmt.Errorf("error reading 'key_ops': %w", err)
		}
	}

	if raw, found := object["kid"]; found {
		err = json.Unmarshal(raw, &t.Kid)
		if err != nil {
			return fmt.Errorf("error reading 'kid': %w", err)
		}
	}

	if raw, found := object["kty"]; found {
		err = json.Unmarshal(raw, &t.Kty)
		if err != nil {
			return fmt.Errorf("error reading 'kty': %w", err)
		}
	}

	if raw, found := object["use"]; found {
		err = json.Unmarshal(raw, &t.Use)
		if err != nil {
			return fmt.Errorf("error reading 'use': %w", err)
		}
	}

	if raw, found := object["x5c"]; found {
		err = json.Unmarshal(raw, &t.X5c)
		if err != nil {
			return fmt.Errorf("error reading 'x5c': %w", err)
		}
	}

	if raw, found := object["x5t"]; found {
		err = json.Unmarshal(raw, &t.X5t)
		if err != nil {
			return fmt.Errorf("error reading 'x5t': %w", err)
		}
	}

	if raw, found := object["x5t#s256"]; found {
		err = json.Unmarshal(raw, &t.X5tS256)
		if err != nil {
			return fmt.Errorf("error reading 'x5t#s256': %w", err)
		}
	}

	if raw, found := object["x5u"]; found {
		err = json.Unmarshal(raw, &t.X5u)
		if err != nil {
			return fmt.Errorf("error reading 'x5u': %w", err)
		}
	}

	return err
}

// AsFSCCoreServiceListingService returns the union data inside the FSCCoreServiceListing_Data as a FSCCoreServiceListingService
func (t FSCCoreServiceListing_Data) AsFSCCoreServiceListingService() (FSCCoreServiceListingService, error) {
	var body FSCCoreServiceListingService
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromFSCCoreServiceListingService overwrites any union data inside the FSCCoreServiceListing_Data as the provided FSCCoreServiceListingService
func (t *FSCCoreServiceListing_Data) FromFSCCoreServiceListingService(v FSCCoreServiceListingService) error {
	v.Type = "TYPE_SERVICE"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeFSCCoreServiceListingService performs a merge with any union data inside the FSCCoreServiceListing_Data, using the provided FSCCoreServiceListingService
func (t *FSCCoreServiceListing_Data) MergeFSCCoreServiceListingService(v FSCCoreServiceListingService) error {
	v.Type = "TYPE_SERVICE"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsFSCCoreServiceListingDelegatedService returns the union data inside the FSCCoreServiceListing_Data as a FSCCoreServiceListingDelegatedService
func (t FSCCoreServiceListing_Data) AsFSCCoreServiceListingDelegatedService() (FSCCoreServiceListingDelegatedService, error) {
	var body FSCCoreServiceListingDelegatedService
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromFSCCoreServiceListingDelegatedService overwrites any union data inside the FSCCoreServiceListing_Data as the provided FSCCoreServiceListingDelegatedService
func (t *FSCCoreServiceListing_Data) FromFSCCoreServiceListingDelegatedService(v FSCCoreServiceListingDelegatedService) error {
	v.Type = "TYPE_DELEGATED_SERVICE"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeFSCCoreServiceListingDelegatedService performs a merge with any union data inside the FSCCoreServiceListing_Data, using the provided FSCCoreServiceListingDelegatedService
func (t *FSCCoreServiceListing_Data) MergeFSCCoreServiceListingDelegatedService(v FSCCoreServiceListingDelegatedService) error {
	v.Type = "TYPE_DELEGATED_SERVICE"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t FSCCoreServiceListing_Data) Discriminator() (string, error) {
	var discriminator struct {
		Discriminator string `json:"type"`
	}
	err := json.Unmarshal(t.union, &discriminator)
	return discriminator.Discriminator, err
}

func (t FSCCoreServiceListing_Data) ValueByDiscriminator() (interface{}, error) {
	discriminator, err := t.Discriminator()
	if err != nil {
		return nil, err
	}
	switch discriminator {
	case "TYPE_DELEGATED_SERVICE":
		return t.AsFSCCoreServiceListingDelegatedService()
	case "TYPE_SERVICE":
		return t.AsFSCCoreServiceListingService()
	default:
		return nil, errors.New("unknown discriminator value: " + discriminator)
	}
}

func (t FSCCoreServiceListing_Data) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *FSCCoreServiceListing_Data) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsFSCLoggingDestination returns the union data inside the FSCLoggingLogRecord_Destination as a FSCLoggingDestination
func (t FSCLoggingLogRecord_Destination) AsFSCLoggingDestination() (FSCLoggingDestination, error) {
	var body FSCLoggingDestination
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromFSCLoggingDestination overwrites any union data inside the FSCLoggingLogRecord_Destination as the provided FSCLoggingDestination
func (t *FSCLoggingLogRecord_Destination) FromFSCLoggingDestination(v FSCLoggingDestination) error {
	v.Type = "DESTINATION_TYPE_DESTINATION"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeFSCLoggingDestination performs a merge with any union data inside the FSCLoggingLogRecord_Destination, using the provided FSCLoggingDestination
func (t *FSCLoggingLogRecord_Destination) MergeFSCLoggingDestination(v FSCLoggingDestination) error {
	v.Type = "DESTINATION_TYPE_DESTINATION"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsFSCLoggingDestinationDelegated returns the union data inside the FSCLoggingLogRecord_Destination as a FSCLoggingDestinationDelegated
func (t FSCLoggingLogRecord_Destination) AsFSCLoggingDestinationDelegated() (FSCLoggingDestinationDelegated, error) {
	var body FSCLoggingDestinationDelegated
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromFSCLoggingDestinationDelegated overwrites any union data inside the FSCLoggingLogRecord_Destination as the provided FSCLoggingDestinationDelegated
func (t *FSCLoggingLogRecord_Destination) FromFSCLoggingDestinationDelegated(v FSCLoggingDestinationDelegated) error {
	v.Type = "DESTINATION_TYPE_DELEGATED_DESTINATION"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeFSCLoggingDestinationDelegated performs a merge with any union data inside the FSCLoggingLogRecord_Destination, using the provided FSCLoggingDestinationDelegated
func (t *FSCLoggingLogRecord_Destination) MergeFSCLoggingDestinationDelegated(v FSCLoggingDestinationDelegated) error {
	v.Type = "DESTINATION_TYPE_DELEGATED_DESTINATION"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t FSCLoggingLogRecord_Destination) Discriminator() (string, error) {
	var discriminator struct {
		Discriminator string `json:"type"`
	}
	err := json.Unmarshal(t.union, &discriminator)
	return discriminator.Discriminator, err
}

func (t FSCLoggingLogRecord_Destination) ValueByDiscriminator() (interface{}, error) {
	discriminator, err := t.Discriminator()
	if err != nil {
		return nil, err
	}
	switch discriminator {
	case "DESTINATION_TYPE_DELEGATED_DESTINATION":
		return t.AsFSCLoggingDestinationDelegated()
	case "DESTINATION_TYPE_DESTINATION":
		return t.AsFSCLoggingDestination()
	default:
		return nil, errors.New("unknown discriminator value: " + discriminator)
	}
}

func (t FSCLoggingLogRecord_Destination) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *FSCLoggingLogRecord_Destination) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsFSCLoggingSource returns the union data inside the FSCLoggingLogRecord_Source as a FSCLoggingSource
func (t FSCLoggingLogRecord_Source) AsFSCLoggingSource() (FSCLoggingSource, error) {
	var body FSCLoggingSource
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromFSCLoggingSource overwrites any union data inside the FSCLoggingLogRecord_Source as the provided FSCLoggingSource
func (t *FSCLoggingLogRecord_Source) FromFSCLoggingSource(v FSCLoggingSource) error {
	v.Type = "SOURCE_TYPE_SOURCE"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeFSCLoggingSource performs a merge with any union data inside the FSCLoggingLogRecord_Source, using the provided FSCLoggingSource
func (t *FSCLoggingLogRecord_Source) MergeFSCLoggingSource(v FSCLoggingSource) error {
	v.Type = "SOURCE_TYPE_SOURCE"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsFSCLoggingSourceDelegated returns the union data inside the FSCLoggingLogRecord_Source as a FSCLoggingSourceDelegated
func (t FSCLoggingLogRecord_Source) AsFSCLoggingSourceDelegated() (FSCLoggingSourceDelegated, error) {
	var body FSCLoggingSourceDelegated
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromFSCLoggingSourceDelegated overwrites any union data inside the FSCLoggingLogRecord_Source as the provided FSCLoggingSourceDelegated
func (t *FSCLoggingLogRecord_Source) FromFSCLoggingSourceDelegated(v FSCLoggingSourceDelegated) error {
	v.Type = "SOURCE_TYPE_DELEGATED_SOURCE"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeFSCLoggingSourceDelegated performs a merge with any union data inside the FSCLoggingLogRecord_Source, using the provided FSCLoggingSourceDelegated
func (t *FSCLoggingLogRecord_Source) MergeFSCLoggingSourceDelegated(v FSCLoggingSourceDelegated) error {
	v.Type = "SOURCE_TYPE_DELEGATED_SOURCE"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t FSCLoggingLogRecord_Source) Discriminator() (string, error) {
	var discriminator struct {
		Discriminator string `json:"type"`
	}
	err := json.Unmarshal(t.union, &discriminator)
	return discriminator.Discriminator, err
}

func (t FSCLoggingLogRecord_Source) ValueByDiscriminator() (interface{}, error) {
	discriminator, err := t.Discriminator()
	if err != nil {
		return nil, err
	}
	switch discriminator {
	case "SOURCE_TYPE_DELEGATED_SOURCE":
		return t.AsFSCLoggingSourceDelegated()
	case "SOURCE_TYPE_SOURCE":
		return t.AsFSCLoggingSource()
	default:
		return nil, errors.New("unknown discriminator value: " + discriminator)
	}
}

func (t FSCLoggingLogRecord_Source) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *FSCLoggingLogRecord_Source) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}
